diff --git a/src/dosext/mfs/mfs.c b/src/dosext/mfs/mfs.c
index bcc350f4f..759c165a3 100644
--- a/src/dosext/mfs/mfs.c
+++ b/src/dosext/mfs/mfs.c
@@ -3389,17 +3389,20 @@ static int dos_fs_redirect(struct vm86_regs *state, char *stk)
         int cnt1 = cnt;
         if (f->seek <= 0xFFFFffff && f->seek + cnt <= 0xFFFFffff) {
           cnt1 = region_lock_offs(f->fd, f->seek, cnt, 0, f->mlemu_fds[1]);
-          if (cnt1 != -1)
-            locked++;
+          if (cnt1 > 0)
+            locked = 1;
         }
         assert(cnt1 <= cnt);
 #if 1
         if (cnt1 <= 0) {  // allow partial reads even though DOS does not
 #else
         if (cnt1 < cnt) {  // partial reads not allowed
-#endif
-          if (locked)
+          if (locked) {
             region_unlock_offs(f->fd);
+            locked = 0;
+          }
+#endif
+          assert(!locked);
           Debug0((dbg_fd, "error, region already locked\n"));
           SETWORD(&state->eax, ACCESS_DENIED);
           return FALSE;
@@ -3485,17 +3488,20 @@ static int dos_fs_redirect(struct vm86_regs *state, char *stk)
         int cnt1 = cnt;
         if (f->seek <= 0xFFFFffff && f->seek + cnt <= 0xFFFFffff) {
           cnt1 = region_lock_offs(f->fd, f->seek, cnt, 1, f->mlemu_fds[1]);
-          if (cnt1 != -1)
-            locked++;
+          if (cnt1 > 0)
+            locked = 1;
         }
         assert(cnt1 <= cnt);
 #if 1
         if (cnt1 <= 0) {  // allow partial writes even though DOS does not
 #else
         if (cnt1 < cnt) {  // partial writes not allowed
-#endif
-          if (locked)
+          if (locked) {
             region_unlock_offs(f->fd);
+            locked = 0;
+          }
+#endif
+          assert(!locked);
           Debug0((dbg_fd, "error, region already locked\n"));
           SETWORD(&state->eax, ACCESS_DENIED);
           return FALSE;
diff --git a/src/dosext/mfs/rlocks.c b/src/dosext/mfs/rlocks.c
index e3ef697bd..cad0c89cb 100644
--- a/src/dosext/mfs/rlocks.c
+++ b/src/dosext/mfs/rlocks.c
@@ -122,13 +122,13 @@ int region_lock_offs(int fd, long long start, unsigned long len, int wr,
   struct flock fl;
   int ret;
 
-  fl.l_type = F_WRLCK;
-  fl.l_start = start;
-  fl.l_len = len;
   /* needs to lock against lock changes in another process */
   ret = flock(fd, LOCK_EX);
   if (ret)
     return -1;
+  fl.l_type = F_WRLCK;
+  fl.l_start = start;
+  fl.l_len = len;
   lock_get(fd, &fl);
   if (fl.l_type == F_UNLCK)
     return len;
@@ -136,14 +136,14 @@ int region_lock_offs(int fd, long long start, unsigned long len, int wr,
   if (fl.l_start > start)
     return (fl.l_start - start);  // found partially unlocked region
   if (wr)
-    return 0;  // writer can't overlap with any lock
+    goto unlock_zero;  // writer can't overlap with any lock
   /* now we are dealing with reader fully overlapping with some lock */
   fl.l_type = F_RDLCK;
   fl.l_start = start;
   fl.l_len = len;
   lock_get(fd, &fl);
   if (fl.l_type != F_UNLCK)
-    return 0;  // overlap was with write lock
+    goto unlock_zero;  // overlap was with write lock
   if (mlemu_fd2 == -1)
     return len;  // no overlap with write lock, free to read
   /* no overlapping write locks but read lock fully overlaps, investigate */
@@ -153,7 +153,11 @@ int region_lock_offs(int fd, long long start, unsigned long len, int wr,
   lock_get(mlemu_fd2, &fl);
   if (fl.l_type != F_UNLCK)
     return len;  // found proper read lock
-  return 0;
+
+unlock_zero:
+  /* no allowed region found, unlock and return 0 */
+  return flock(fd, LOCK_UN);
+;
 }
 
 void region_unlock_offs(int fd)
